// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
// Copyright (C) 2012-2013	JoostinOnline

/*
init.h

Startup and shutdown functions
*/
#ifndef __INIT_H__
#define __INIT_H__

#include "grlib/grlib.h"

extern GRRLIB_texImg *bkg;

typedef struct s_present
	{
	bool enabled; // Is SE_settings.cfg valid?

	// Values in SE_settings.cfg file
	int resolution;
	int widescreen;
	int sensorbar;
	int soundmode;
	int rumble;
	int burnin;
	int shutdown;
	int sensitivity;
	int wc24;
	int auto_exit; // Auotmatically save and exit after loading present.cfg
	char exit_to[8]; // Channel to exit to
	}
s_present;

extern s_present present;

int Initialize(void);
bool LoadPresentCfg(char *path);
int LoadFont(char *path);
int LoadTheme(int dev);
void ScanTheme(void);
void fadeOut(void);
bool CheckIfNeek(void);
bool CheckIfNeek2(void);
int Deinit (void);

#endif